/*******************************************************************
 * nCZT@@HMC5883L@@I2C2gp
 *  PIC24FJ256GA702@FOSC=32MHz
 *@3̒nCf[^PCɃVAőM
 *******************************************************************/
#include <xc.h>
/* RtBM[V̐ݒ */
// FSEC
#pragma config BWRP = OFF               // Boot Segment Write-Protect bit (Boot Segment may be written)
#pragma config BSS = DISABLED           // Boot Segment Code-Protect Level bits (No Protection (other than BWRP))
#pragma config BSEN = OFF               // Boot Segment Control bit (No Boot Segment)
#pragma config GWRP = OFF               // General Segment Write-Protect bit (General Segment may be written)
#pragma config GSS = DISABLED           // General Segment Code-Protect Level bits (No Protection (other than GWRP))
#pragma config CWRP = OFF               // Configuration Segment Write-Protect bit (Configuration Segment may be written)
#pragma config CSS = DISABLED           // Configuration Segment Code-Protect Level bits (No Protection (other than CWRP))
#pragma config AIVTDIS = OFF            // Alternate Interrupt Vector Table bit (Disabled AIVT)
// FBSLIM
#pragma config BSLIM = 0x1FFF           // Boot Segment Flash Page Address Limit bits (Boot Segment Flash page address  limit)
// FSIGN
// FOSCSEL
#pragma config FNOSC = FRCPLL           // Oscillator Source Selection (Fast RC Oscillator with divide-by-N with PLL module (FRCPLL) )
#pragma config PLLMODE = DISABLED       // PLL Mode Selection (No PLL used; PLLEN bit is not available)
#pragma config IESO = OFF               // Two-speed Oscillator Start-up Enable bit (Start up with user-selected oscillator source)
// FOSC
#pragma config POSCMD = NONE            // Primary Oscillator Mode Select bits (Primary Oscillator disabled)
#pragma config OSCIOFCN = OFF           // OSC2 Pin Function bit (OSC2 is clock output)
#pragma config SOSCSEL = ON             // SOSC Power Selection Configuration bits (SOSC is used in crystal (SOSCI/SOSCO) mode)
#pragma config PLLSS = PLL_PRI          // PLL Secondary Selection Configuration bit (PLL is fed by the Primary oscillator)
#pragma config IOL1WAY = OFF            // Peripheral pin select configuration bit (Allow multiple reconfigurations)
#pragma config FCKSM = CSDCMD           // Clock Switching Mode bits (Both Clock switching and Fail-safe Clock Monitor are disabled)
// FWDT
#pragma config WDTPS = PS32768          // Watchdog Timer Postscaler bits (1:32,768)
#pragma config FWPSA = PR128            // Watchdog Timer Prescaler bit (1:128)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable bits (WDT and SWDTEN disabled)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable bit (Watchdog Timer in Non-Window mode)
#pragma config WDTWIN = WIN25           // Watchdog Timer Window Select bits (WDT Window is 25% of WDT period)
#pragma config WDTCMX = WDTCLK          // WDT MUX Source Select bits (WDT clock source is determined by the WDTCLK Configuration bits)
#pragma config WDTCLK = LPRC            // WDT Clock Source Select bits (WDT uses LPRC)
// FPOR
#pragma config BOREN = ON               // Brown Out Enable bit (Brown Out Enable Bit)
#pragma config LPCFG = OFF              // Low power regulator control (No Retention Sleep)
#pragma config DNVPEN = ENABLE          // Downside Voltage Protection Enable bit (Downside protection enabled using ZPBOR when BOR is inactive)
// FICD
#pragma config ICS = PGD1               // ICD Communication Channel Select bits (Communicate on PGEC1 and PGED1)
#pragma config JTAGEN = OFF             // JTAG Enable bit (JTAG is disabled)
// FDEVOPT1
#pragma config ALTCMPI = DISABLE        // Alternate Comparator Input Enable bit (C1INC, C2INC, and C3INC are on their standard pin locations)
#pragma config TMPRPIN = OFF            // Tamper Pin Enable bit (TMPRN pin function is disabled)
#pragma config SOSCHP = ON              // SOSC High Power Enable bit (valid only when SOSCSEL = 1 (Enable SOSC high power mode (default))
#pragma config ALTI2C1 = ALTI2CEN       // Alternate I2C pin Location (SDA1 and SCL1 on RB9 and RB8)

/* \bZ[W */
unsigned char SndBuf[] = "X=+xxxxxx, Y=+xxxxxx, Z=+xxxxxx\r\n";
long Xdata, Ydata, Zdata;

/** ֐vg^CsO */
void CompassInit(void);
void GetCompass(void);
void Send(unsigned char data1);
void SendStr(unsigned char *buf1);
void GetDataI2C2(unsigned char cmnd, unsigned char *Buffer, unsigned char CNT);
void CmdI2C2(unsigned char cmnd, unsigned char data);
void IdleI2C2(void);
void DataTrans(unsigned char sData);
void Delay100ms(unsigned int t);
void itostring(char digit, unsigned int data, unsigned char *buffer);
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer);
void ftostring(int seisu, int shousu, double data, unsigned char *buffer);

/************ C֐ ********************/
int main(void){
    /* o̓|[gݒ  */
    ANSA = 0;                       // ׂăfW^
    ANSB = 0;
    TRISA = 0x0010;                 //
    TRISB = 0x3397;                 //  
    /* UART1st */
    RPINR18bits.U1RXR = 6;          // UART1 RX to RP6
    RPOR3bits.RP7R = 3;             // UART1 TX to RP7
    /* UART1ݒ@115kbps  */
    U1MODE = 0x8808;                // UART1ݒ BRGH=1
    U1STA =  0x0400;                // UART1ݒ
    U1BRG = 34;                     // 115kbps@16MHz
    /* I2C2 */
    I2C2BRG = 0x4E;                 // 100kHz@16MHz
    I2C2CONL = 0x8000;              // I2C2Cl[u
    CompassInit();                  // ZTݒ
    /****** C[v ******/
    while(1){
        GetCompass();                   // nCf[^擾
        SndBuf[2] = ' ';                // Xf[^𕶎ɕϊ
        if(Xdata < 0){                  // f[^̏ꍇ
            Xdata *= -1;                // ̒lɂ
            SndBuf[3] = '-';            // -L
        }
        ltostring(6, Xdata, SndBuf+3);  // 
        SndBuf[13] = ' ';               // Yf[^𕶎ɕϊ
        if(Ydata < 0){                  // Y̏ꍇ
            Ydata *= -1;                // ɂ
            SndBuf[13] = '-';           // -L
        }
        ltostring(6, Ydata, SndBuf+14); // 
        SndBuf[24] = ' ';               // Z𕶎ɕϊ
        if(Zdata < 0){                  // ̏ꍇ
            Zdata *= -1;                // ɂ
            SndBuf[24] = '-';           // -L
        }
        ltostring(6, Zdata, SndBuf+25); //           
        SendStr(SndBuf);                // PCɑM
        Delay100ms(10);                 // 1b҂
    }
}
/**********************************************
 * nCZT֐
 * 8񕽋ρAAϊ@GAIN=5
 * 15HzŌJԂϊ
 *********************************************/
void CompassInit(void){
    CmdI2C2(0, 0x70);       // ConfigA 8 avarage 15Hz Out
    CmdI2C2(0x01, 0xA0);    // Config B Gain=5
    CmdI2C2(0x02, 0);       // Continuous mode
}
/**********************************************
 * 3̒nC擾֐
 *@Data@X Z Y̏
 **********************************************/
void GetCompass(void){
    union{
        unsigned char buf[6];
        int ibuf[3];
    }data;
    
    GetDataI2C2(0x03, &data.buf[0], 6);      // f[^Aǂݏo
    Xdata = data.ibuf[0];
    Zdata = data.ibuf[1];
    Ydata = data.ibuf[2];
}
/**********************************************************
* I2C21oCg̃R}hf[^𑗐M
 * Address + Command + data
**********************************************************/
void CmdI2C2(unsigned char cmnd, unsigned char data)
{
    IdleI2C2();
    I2C2CONLbits.SEN = 1;           // X^[go//
    while(I2C2CONLbits.SEN);        // X^[gI҂//
    DataTrans(0x3C);                // AhXM
    DataTrans(cmnd);                // Command RegisterM
    DataTrans(data);                // R}hf[^M
    I2C2CONLbits.PEN = 1;           // Xgbvo//
    while(I2C2CONLbits.PEN);        // XgbvI҂//
}
/**********************************************
 * I2C2ŎwoCg̃f[^M
***********************************************/
void GetDataI2C2(unsigned char cmnd, unsigned char *Buffer, unsigned char CNT)
{
    unsigned char i;
    /** ǂݏoJnWX^AhXo */
    IdleI2C2();
    I2C2CONLbits.SEN = 1;               // X^[go//
    while(I2C2CONLbits.SEN);            // X^[gI҂//
    DataTrans(0x3C);                    // AhXM
    DataTrans(cmnd);                    // CommandMiWX^AhXj
    I2C2CONLbits.PEN = 1;               // Xgbvo//
    while(I2C2CONLbits.PEN);            // XgbvI҂//
    /** }`oCgǂݏo */
    IdleI2C2();                         // ACh҂
    I2C2STATbits.I2COV = 0;             // G[NA//
    I2C2CONLbits.SEN = 1;               // X^[go//
    while(I2C2CONLbits.SEN);            // X^[gI҂
    DataTrans(0x3D);                    // AhXM Read[h
    for(i=0; i<CNT-1; i++) {            // oCgAM//
        I2C2CONLbits.ACKDT = 0;         // ACKݒ//
        I2C2CONLbits.RCEN = 1;          // M//
        while(I2C2CONLbits.RCEN);       // M҂//
        I2C2CONLbits.ACKEN = 1;         // ACKԑ//
        Buffer[i] = I2C2RCV;            // Mf[^擾//
        IdleI2C2();                     // ACh҂//
    }
    I2C2CONLbits.ACKDT = 1;             // NACKݒ//
    I2C2CONLbits.RCEN = 1;              // M//
    while(I2C2CONLbits.RCEN);           // M҂//
    I2C2CONLbits.ACKEN = 1;             // NACKԑ//
    Buffer[i] = I2C2RCV;                // Mf[^擾//
    IdleI2C2();                         // ACh҂//
    I2C2CONLbits.PEN = 1;               // Xgbvo//
    while(I2C2CONLbits.PEN);            // XgbvI҂//
}
/**************************************
 *  I2C21oCgM֐ 
 *************************************/
void DataTrans(unsigned char sData){
    IFS3bits.MI2C2IF = 0;
    I2C2TRN = sData;                    // f[^M//
    while(IFS3bits.MI2C2IF == 0);       // MI҂//
}
/*************************************
 *  ACh҂Tu֐@
 ************************************/
void IdleI2C2(void){
    /* Wait until I2C Bus is Inactive */
    while(I2C2CONLbits.SEN || I2C2CONLbits.PEN || I2C2CONLbits.RCEN
    		 || I2C2CONLbits.ACKEN || I2C2STATbits.TBF || I2C2STATbits.RBF);
}
/***************************************************
 * 100msecx֐@^C}2gp Fosc=16MHz
 ***************************************************/
void Delay100ms(unsigned int t){
    IFS0bits.T2IF = 0;              // 荞݃tONA
    PR2 = 25000;                     // 100msecݒ
    T2CON = 0x8020;                 // ^C}4X^[g@vXP[ 1/64
    while (t--) {                   // JԂ
        while (!IFS0bits.T2IF);     // ҂
        IFS0bits.T2IF = 0;          // 荞݃tONA
    }
}
/********************************
 * UART1 MsTu֐
 ********************************/
void Send(unsigned char data1){
    while(!U1STAbits.TRMT);              // MfB[҂
    U1TXREG = data1;                     // Ms
}
/*******************************************
 * UART1񑗐M֐
 *******************************************/
void SendStr(unsigned char * buf1)
{
    while(*buf1 != 0){                   // ̏I܂
        Send(*buf1++);                   // 
    }
}
/**************************************
 *  l當ɕϊ
 * ***********************************/
void itostring(char digit, unsigned int data, unsigned char *buffer)
{
    int i;

    buffer += digit;                    // ̍Ō
    for(i=digit; i>0; i--) {            // ŉʌʂ
        buffer--;                       // |C^[P
        *buffer = (data % 10) + '0';    // ̌l𕶎ɂĊi[
        data = data / 10;               // -1
    }
}
/***************************************
* longASCIIɕϊ
****************************************/
void ltostring(unsigned char digit, unsigned long data, unsigned char *buffer){
    unsigned char i;

    buffer += digit;                        // Ō̐ʒu
    for(i=digit; i>0; i--) {                // ϊ͉ʂʂ
        buffer--;                           // |C^[P
        *buffer = (data % 10) + '0';        // ASCII
        data = data / 10;                   // ̌
    }
}
/***********************************
* Float當֕ϊ
* vL8ȉƂ邱
***********************************/
void ftostring(int seisu, int shousu, double data, unsigned char *buffer)
{
    int i;
    long dumy;

    if(shousu != 0)                         //肩
        buffer += seisu+shousu+1;           //Š{_
    else                                    //Ȃ̂Ƃ
        buffer += seisu + shousu;           //Š̂
    buffer--;                               //z|C^-1
    for(i=0; i<shousu; i++)                 //𐮐ɕϊ
        data = data * 10;                   //PO{
    /* dumyI[o[t[ƕϊs(WE) */
    dumy = (long) (data + 0.5);             //ľܓĐɕϊ
    for(i=shousu; i>0; i--) {               //JԂ
        *buffer =(dumy % 10)+'0';           //l𕶎ɕϊi[
        buffer--;                           //i[ꏊʂʂ
        dumy /= 10;                         //̌
    }
    if(shousu != 0) {                       //0Ȃ珬_Ȃ
        *buffer = '.';                      //_i[
        buffer--;                           //|C^-1
    }
    for(i=seisu; i>0; i--) {                //JԂ
        *buffer = (dumy % 10)+'0';          //l𕶎ɕϊi[
        buffer--;                           //|C^-1
        dumy /= 10;                         //̌
    }
}
    