/*******************************************************************
 * hbvZT@@NJR4265 J1@9600bps
 *  PIC24FJ256GA702@FOSC=32MHz
 *@hbv|[Oڋ߂UARTPCɑM
 *@o͏ݒōs
 *******************************************************************/
#include <xc.h>
/* RtBM[V̐ݒ */
// FSEC
#pragma config BWRP = OFF               // Boot Segment Write-Protect bit (Boot Segment may be written)
#pragma config BSS = DISABLED           // Boot Segment Code-Protect Level bits (No Protection (other than BWRP))
#pragma config BSEN = OFF               // Boot Segment Control bit (No Boot Segment)
#pragma config GWRP = OFF               // General Segment Write-Protect bit (General Segment may be written)
#pragma config GSS = DISABLED           // General Segment Code-Protect Level bits (No Protection (other than GWRP))
#pragma config CWRP = OFF               // Configuration Segment Write-Protect bit (Configuration Segment may be written)
#pragma config CSS = DISABLED           // Configuration Segment Code-Protect Level bits (No Protection (other than CWRP))
#pragma config AIVTDIS = OFF            // Alternate Interrupt Vector Table bit (Disabled AIVT)
// FBSLIM
#pragma config BSLIM = 0x1FFF           // Boot Segment Flash Page Address Limit bits (Boot Segment Flash page address  limit)
// FSIGN
// FOSCSEL
#pragma config FNOSC = FRCPLL           // Oscillator Source Selection (Fast RC Oscillator with divide-by-N with PLL module (FRCPLL) )
#pragma config PLLMODE = DISABLED       // PLL Mode Selection (No PLL used; PLLEN bit is not available)
#pragma config IESO = OFF               // Two-speed Oscillator Start-up Enable bit (Start up with user-selected oscillator source)
// FOSC
#pragma config POSCMD = NONE            // Primary Oscillator Mode Select bits (Primary Oscillator disabled)
#pragma config OSCIOFCN = OFF           // OSC2 Pin Function bit (OSC2 is clock output)
#pragma config SOSCSEL = ON             // SOSC Power Selection Configuration bits (SOSC is used in crystal (SOSCI/SOSCO) mode)
#pragma config PLLSS = PLL_PRI          // PLL Secondary Selection Configuration bit (PLL is fed by the Primary oscillator)
#pragma config IOL1WAY = OFF            // Peripheral pin select configuration bit (Allow multiple reconfigurations)
#pragma config FCKSM = CSDCMD           // Clock Switching Mode bits (Both Clock switching and Fail-safe Clock Monitor are disabled)
// FWDT
#pragma config WDTPS = PS32768          // Watchdog Timer Postscaler bits (1:32,768)
#pragma config FWPSA = PR128            // Watchdog Timer Prescaler bit (1:128)
#pragma config FWDTEN = OFF             // Watchdog Timer Enable bits (WDT and SWDTEN disabled)
#pragma config WINDIS = OFF             // Watchdog Timer Window Enable bit (Watchdog Timer in Non-Window mode)
#pragma config WDTWIN = WIN25           // Watchdog Timer Window Select bits (WDT Window is 25% of WDT period)
#pragma config WDTCMX = WDTCLK          // WDT MUX Source Select bits (WDT clock source is determined by the WDTCLK Configuration bits)
#pragma config WDTCLK = LPRC            // WDT Clock Source Select bits (WDT uses LPRC)
// FPOR
#pragma config BOREN = ON               // Brown Out Enable bit (Brown Out Enable Bit)
#pragma config LPCFG = OFF              // Low power regulator control (No Retention Sleep)
#pragma config DNVPEN = ENABLE          // Downside Voltage Protection Enable bit (Downside protection enabled using ZPBOR when BOR is inactive)
// FICD
#pragma config ICS = PGD1               // ICD Communication Channel Select bits (Communicate on PGEC1 and PGED1)
#pragma config JTAGEN = OFF             // JTAG Enable bit (JTAG is disabled)
// FDEVOPT1
#pragma config ALTCMPI = DISABLE        // Alternate Comparator Input Enable bit (C1INC, C2INC, and C3INC are on their standard pin locations)
#pragma config TMPRPIN = OFF            // Tamper Pin Enable bit (TMPRN pin function is disabled)
#pragma config SOSCHP = ON              // SOSC High Power Enable bit (valid only when SOSCSEL = 1 (Enable SOSC high power mode (default))
#pragma config ALTI2C1 = ALTI2CEN       // Alternate I2C pin Location (SDA1 and SCL1 on RB9 and RB8)

/**** ϐ`@***/
#define  LED   LATBbits.LATB5
#define  Frc    16000000 
/* \bZ[W */
unsigned char Data, i, rcv;
unsigned char buf[32];
unsigned char MsgC[] = "Close\r\n";
unsigned char MsgL[] = "Leave\r\n";
unsigned char MsgQ[] = "@SP?\r\n";
/** ֐vg^CsO */
void DopInit(void);
unsigned char GetDop(unsigned char *buf);
unsigned char RecvUART2(void);
void Send(unsigned char data1);
void SendStr(unsigned char *buf1);
void Send2(unsigned char data2);
void SendStr2(unsigned char *buf2);
void Delay100ms(unsigned int t);

/************ C֐ ********************/
int main(void){
    /* o̓|[gݒ  */
    ANSA = 0;                       // ׂăfW^
    ANSB = 0;
    LATBbits.LATB3 = 1;
    TRISA = 0x0010;                 //
    TRISB = 0x3397;                 //  
    /* UART1st */
    RPINR18bits.U1RXR = 6;          // UART1 RX to RP6
    RPOR3bits.RP7R = 3;             // UART1 TX to RP7
    /* UART1ݒ@115kbps  */
    U1MODE = 0x8808;                // UART1ݒ BRGH=1
    U1STA =  0x0400;                // UART1ݒ
    U1BRG = 34;                     // 115kbps@16MHz
    /* UART2st */
    RPINR19bits.U2RXR = 2;          // UART2 RX to RP2
    RPOR1bits.RP3R = 5;             // UART2 TX to RP3
    /* UART2ݒ@9600bps  */
    U2MODE = 0x880C;                // UART2ݒ BRGH=1 Odd Parity
    U2STA =  0x0400;                // UART2ݒ@TX Enable
    U2BRG = 416;                    // 9600bps@16MHz
    DopInit();
    /*********** C[v ***************/
    while(1)  {
        /* ZT|[O */
        Data = GetDop(buf);             // ZTf[^擾
        if(Data != 0){                  // f[^̏ꍇ
            LED ^= 1;                   // ڈLED
            if(Data == 'C'){            // ڋ
                SendStr(MsgC);
            }
            else if(Data == 'L'){       // 
                SendStr(MsgL);
            }
        }
//        Delay100ms(30);        
//        SendStr2(MsgQ);
//        i = 0;
//        while(buf[i-1] != '\n'){
//            buf[i++] = RecvUART2();
//        }
//        buf[i] = 0;
//        SendStr(buf);
    }
}
/***********************************************
 * hbvZTݒ
 *@샂[hƌmݒ
 **********************************************/
unsigned char MsgT[] = "@T\r\n";
unsigned char MsgSP[] = "@SP100\r\n";
unsigned char MsgSM[] = "@SM150\r\n";
void DopInit(void){
    SendStr2(MsgT);         // m[hɂ
    SendStr2(MsgSP);        // ڋߋ100cm
    SendStr2(MsgSM);        // 150cm
}
/*********************************************
 *  hbvZTԎ擾
 * 
 *********************************************/
unsigned char GetDop(unsigned char *buf){
    unsigned char temp;

    temp = RecvUART2();                 // 1M
    if(temp != 0xFF){                   // MG[łȂ
        buf[i++] = temp;                // f[^i[
        if(temp == '\n'){               // IR[ho
            if(buf[i-4] == '@')         // JnR[hmF
                return(buf[i-3]);       // @̎̕Ԃ
        }
        if(i > 30)                      // obt@I[o[
            i = 0;                      // ŏɖ߂
    }
    return(buf[0]);                     // @ȊȌꍇ0Ԃ
}
/************************************************
 *  UART2@M֐@9600bps
 *@  G[FFF@Ff[^@
************************************************/
unsigned char RecvUART2(void){
    unsigned char dumy;
    /* 1M҂ */
    while(IFS1bits.U2RXIF == 0);            // M҂
    /* MG[`FbN */
    IFS1bits.U2RXIF = 0;                    // 荞݃tONA
    if(U2STAbits.OERR || U2STAbits.FERR || U2STAbits.PERR) {
        dumy = U2RXREG;;
        U2STA &= 0xFFF0;                    // G[tONA
        U2MODE = 0;                         // UART2~
        U2MODE = 0x880C;                    // UART2L       
        return(0xFF);                       // G[tOԂ
    }
    else {                                  // M̏ꍇ
        return(U2RXREG);                    // Mf[^Ԃ
    }
}

/********************************
 * UART2 MsTu֐
 ********************************/
void Send2(unsigned char data2){
    while(!U2STAbits.TRMT);              // MfB[҂
    U2TXREG = data2;                      // Ms
}
/*******************************************
 * UART2񑗐M֐
 *******************************************/
void SendStr2(unsigned char * buf2)
{
    while(*buf2 != 0){                   // ̏I܂
        Send2(*buf2++);                   // 
    }
}

/********************************
 * UART1 MsTu֐
 ********************************/
void Send(unsigned char data1){
    while(!U1STAbits.TRMT);              // MfB[҂
    U1TXREG = data1;                      // Ms
}
/*******************************************
 * UART1񑗐M֐
 *******************************************/
void SendStr(unsigned char * buf1)
{
    while(*buf1 != 0){                   // ̏I܂
        Send(*buf1++);                   // 
    }
}
/***************************************************
 * 100msecx֐@^C}2gp Fosc=16MHz
 ***************************************************/
void Delay100ms(unsigned int t){
    IFS0bits.T2IF = 0;              // 荞݃tONA
    PR2 = 25000;                     // 100msecݒ
    T2CON = 0x8020;                 // ^C}4X^[g@vXP[ 1/64
    while (t--) {                   // JԂ
        while (!IFS0bits.T2IF);     // ҂
        IFS0bits.T2IF = 0;          // 荞݃tONA
    }
}
